
/**
 * About rendering Outline fonts (vector fonts) in Processing.js
 */

String[] fonts = { 
    "verdana.svg", "automat.svg"
};
int curfont = 0;



void setup() 
{
    size( 800, 400);

    // set the default glyph size
    mouseY = 64;

    // loading SVG fonts definition
    loadFont( fonts[0] ); // or use loadGlyphs(fonts[0]);
    loadFont( fonts[1] ); // or use loadGlyphs(fonts[1]);
}


void draw() 
{
    background(51);

    float size    = mouseY;
    float ascent  = glyphAscent(fonts[curfont])*size;
    float descent = glyphDescent(fonts[curfont])*size;
    float middle  = (height/2) + ((ascent+descent)/2) - descent;

    // draw usage
    fill( #666666 );
    text( "click to change font and move along y-axis to scale glyphs", 10, 20 );

    // draw glyphs
    noStroke();
    fill( #FFFFFF );
    glyph( "Lorem Ipsum", width/2, middle, size, CENTER, fonts[curfont] );

    // draw glyphs ascent, descent and base lines
    stroke( #666666 );
    line( 0, middle-ascent, width, middle-ascent );
    line( 0, middle+descent, width, middle+descent );
    line( 0, middle, width, middle );
}

void mouseReleased()
{
    curfont = int(!curfont);
}



